代码随想录算法训练营第三天 | 203,707,206

203

class Solution {
public:
    ListNode* removeElements(ListNode* head, int val) {
        ListNode* dummy_node = new ListNode(-1, head);
        ListNode* curr = dummy_node;
        while(curr->next!=nullptr) {
            if (curr->next->val == val) {
                ListNode* tmp = curr->next;
                curr->next = curr->next->next;
                delete tmp;
            }
            else {
                curr = curr->next;
            }
        }
        return dummy_node->next;
    }
};

总结1: 记得c++要手动管理内存

总结2: 设置虚拟头节点要比直接在原链表操作容易且不易出错。

707

class MyLinkedList {

public:
    struct LinkedList {
        int val;
        LinkedList *next;
        LinkedList(int val): val(val), next(nullptr){} 
    };

    MyLinkedList() {
        dummy_node = new LinkedList(0);
        size = 0;
    }
    
    int get(int index) {
        if (index<0 || index>=size) {
            return -1;
        }
        
        LinkedList * curr = dummy_node;
        for (int i=0; i<index+1; i++) {
            curr = curr->next;
        }
        return curr->val;
    }
    
    void addAtHead(int val) {
        LinkedList * added_node = new LinkedList(val);
        LinkedList * temp = dummy_node->next;
        dummy_node->next = added_node;
        added_node->next = temp;
        size++;
    }
    
    void addAtTail(int val) {
        LinkedList * curr = dummy_node;
        while (curr->next!= nullptr) {
            curr = curr->next;
        }
        LinkedList * added_node = new LinkedList(val);
        curr->next = added_node;
        size++;
    }
    
    void addAtIndex(int index, int val) {
        if (index<0 || index>size) {
            return;
        }
        LinkedList * curr = dummy_node;
        for (int i=0; i<index && curr->next!= nullptr; i++) {
            curr = curr->next;
        }
        LinkedList * added_node = new LinkedList(val);
        LinkedList * temp = curr->next;
        curr->next = added_node;
        added_node->next = temp;
        size++;
    }
    
    void deleteAtIndex(int index) {
        if (index<0 || index>=size) {
            return;
        }
        LinkedList * curr = dummy_node;
        for (int i=0; i<index && curr->next!= nullptr; i++) {
            curr = curr->next;
        }
        LinkedList * delete_node = curr->next;
        curr->next = delete_node->next;
        size--;
    }

private:
    int size;
    LinkedList * dummy_node;


};

总结1: 仍然是虚拟头节点的运用

总结2: 加入运用size,让有index为参数的函数更方便

206

class Solution {
public:
    ListNode* reverseList(ListNode* head) {
        ListNode* prev = nullptr;
        ListNode* curr = head;
        while (curr != nullptr) {
            ListNode* next = curr->next;
            curr->next = prev;
            prev = curr;
            curr = next;
        }
        return prev;
    }
};

总结:画图,一步步操作,搞清楚最后return的是什么

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二天的算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,使得子数组的和大于等于给定的目标值。这里可以使用滑动窗口的方法来解决问题。使用两个指针来表示滑动窗口的左边界和右边界,通过移动指针来调整滑动窗口的大小,使得滑动窗口中的元素的和满足题目要求。具体实现的代码如下: ```python def minSubArrayLen(self, target: int, nums: List[int]) -> int: left = 0 right = 0 ans = float('inf') total = 0 while right < len(nums): total += nums[right] while total >= target: ans = min(ans, right - left + 1) total -= nums[left] left += 1 right += 1 return ans if ans != float('inf') else 0 ``` 以上就是第二十二天的算法训练营的内容。通过这些题目的练习,可以提升对双指针和滑动窗口等算法的理解和应用能力。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值